"use strict";

var _classCallCheck = require("babel-runtime/helpers/class-call-check")["default"];

var _inherits = require("babel-runtime/helpers/inherits")["default"];

var _get = require("babel-runtime/helpers/get")["default"];

var _createClass = require("babel-runtime/helpers/create-class")["default"];

var _core = require("babel-runtime/core-js")["default"];

var _interopRequire = require("babel-runtime/helpers/interop-require")["default"];

var Storm = _interopRequire(require("./storm"));

var Bolt = (function (_Storm) {
    function Bolt() {
        var _this = this;

        _classCallCheck(this, Bolt);

        _get(_core.Object.getPrototypeOf(Bolt.prototype), "constructor", this).call(this);

        this.onheartbeat = function () {
            return _this.sync();
        };
        this.ontuple = function (tuple) {

            _this.process(tuple, function (error) {
                if (error) {
                    _this.log(error.stack || "An unknown error occurred.");
                    _this.send({ command: "fail", id: tuple.id });
                    return;
                }
                _this.send({ command: "ack", id: tuple.id });
            });
        };
    }

    _inherits(Bolt, _Storm);

    _createClass(Bolt, {
        attach: {
            value: function attach(dispatcher) {
                _get(_core.Object.getPrototypeOf(Bolt.prototype), "attach", this).call(this, dispatcher);
                this.dispatcher.on("heartbeat", this.onheartbeat);
                this.dispatcher.on("tuple", this.ontuple);
            }
        },
        detach: {
            value: function detach() {
                this.dispatcher.removeEventListener("tuple", this.ontuple);
                this.dispatcher.removeEventListener("heartbeat", this.onheartbeat);
                _get(_core.Object.getPrototypeOf(Bolt.prototype), "detach", this).call(this);
            }
        },
        process: {
            value: function process(tuple, done) {
                throw new Error("Not implemented.");
            }
        },
        transformMessage: {
            value: function transformMessage(_ref) {
                var tuple = _ref.tuple;
                var stream = _ref.stream;
                var task = _ref.task;
                var anchorTupleId = _ref.anchorTupleId;

                return {
                    tuple: tuple,
                    stream: stream,
                    task: task,
                    anchors: [anchorTupleId]
                };
            }
        }
    });

    return Bolt;
})(Storm);

module.exports = Bolt;