"use strict";

var _classCallCheck = require("babel-runtime/helpers/class-call-check")["default"];

var _createClass = require("babel-runtime/helpers/create-class")["default"];

var _interopRequire = require("babel-runtime/helpers/interop-require")["default"];

var Thrift = _interopRequire(require("thrift"));

var Client = require("./generated/Nimbus").Client;

function getConfiguredClient(_ref) {
    var host = _ref.host;
    var _ref$port = _ref.port;
    var port = _ref$port === undefined ? 6627 : _ref$port;
}

var StormSubmitter = (function () {
    function StormSubmitter() {
        _classCallCheck(this, StormSubmitter);
    }

    _createClass(StormSubmitter, null, {
        submitTopology: {
            value: function submitTopology(name, uploadedJarLocation, _ref, topology, callback) {
                var nimbus = _ref.nimbus;
                var config = _ref.config;
                var host = nimbus.host;
                var port = nimbus.port;

                var conn = Thrift.createConnection(host, port, { transport: Thrift.TFramedTransport });
                var client = Thrift.createClient(Client, conn);

                client.getClusterInfo(function (err, _ref2) {
                    var topologies = _ref2.topologies;

                    if (err) {
                        callback(err);
                        return;
                    }

                    if (topologies.indexOf(name) !== -1) {
                        callback(new Error("Topology with name `" + name + "` already exists on cluster"));
                        return;
                    }

                    client.submitTopology(name, uploadedJarLocation, JSON.stringify(config), topology, function (err, result) {
                        conn.connection.unref();
                        callback(err, result);
                    });
                });
            }
        },
        submitTopologyWithOpts: {
            value: function submitTopologyWithOpts() {
                throw new Error("Not implemented.");
            }
        },
        killTopology: {
            value: function killTopology(name, cb) {
                throw new Error("Not implemented.");
            }
        },
        killTopologyWithOpts: {
            value: function killTopologyWithOpts() {
                throw new Error("Not implemented.");
            }
        }
    });

    return StormSubmitter;
})();

module.exports = StormSubmitter;