"use strict";

var _core = require("babel-runtime/core-js")["default"];

var _interopRequire = require("babel-runtime/helpers/interop-require")["default"];

var Fs = _interopRequire(require("fs"));

var Path = _interopRequire(require("path"));

var _fsExtra = require("fs-extra");

var mkdirp = _fsExtra.mkdirpSync;
var rimraf = _fsExtra.removeSync;
var cp = _fsExtra.copySync;

function findup(_x, _x2) {
    var _again = true;

    _function: while (_again) {
        _again = false;
        var dir = _x,
            file = _x2;
        files = _iteratorNormalCompletion = _didIteratorError = _iteratorError = parent = undefined;

        var files = Fs.readdirSync(dir);

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = _core.$for.getIterator(files), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var filename = _step.value;

                if (filename === file) {
                    return Path.join(dir, filename);
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator["return"]) {
                    _iterator["return"]();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }

        var parent = Path.dirname(dir);
        if (parent === dir || parent === "/") {
            return undefined;
        }

        _x = parent;
        _x2 = file;
        _again = true;
        continue _function;
    }
}

module.exports = {

    cp: cp,

    rimraf: rimraf,

    mkdirp: mkdirp,

    // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random
    randInt: function randInt(min, max) {
        return Math.floor(Math.random() * (max - min)) + min;
    },

    defer: function defer() {
        var deferred = {};
        deferred.promise = new _core.Promise(function (resolve, reject) {
            deferred.resolve = resolve;
            deferred.reject = reject;
        });
        return deferred;
    },

    findroot: function findroot(dir) {
        dir = Path.resolve(dir);

        if (Fs.statSync(dir).isFile()) {
            dir = Path.dirname(dir);
        }

        return Path.dirname(findup(dir, "package.json"));
    },

    relative: function relative(topology) {
        var abs = Path.resolve(topology);
        var root = this.findroot(abs);
        return Path.relative(root, abs);
    }
};